public class DFS_seznam{
 
 private Vrchol [] vrcholy  ;  // deklarace pole typu Vrchol  
  
//**********************************************************************

   private class Soused {   // Prvky tridy soused tvori pomoci spojovych struktur seznam sousedu kazdeho vrcholu 
      Vrchol v;
      int hod;
      Soused dalsi;
   
      
      Soused (int hod) {
        this.hod=hod;
        dalsi = null;

      }
    }
    
   //************************************************************ 
  
     private class Vrchol {   
    char barva;
    int vzdalenost;
    int predchudce;
    int objeven;
    int dokoncen;
    Soused sousedi;
    
    Vrchol () {
      sousedi = null;
      vzdalenost = -1;
      barva= 'B';
      objeven = 0;
      dokoncen = 0;
      
    }
  }
//*********************************************************************
    
    private class IntFronta {     // Trida intFronta slouzi k ukladani indexu sousedu pri pruchodu grafem
  
    private class Clen {
      int klic;
      Clen dalsi;
    
      Clen(int klic) {
        this.klic = klic;
        this.dalsi = null;
      }
    }
  
    private Clen zacatek, konec;
  
    IntFronta() {
      zacatek = null;
      konec = null;
    }
  
    boolean jePrazdna() {
      return (zacatek == null);
    }
  
    void vloz(int klic) {
      Clen k = konec;
      konec = new Clen(klic);
      if (jePrazdna()) {
        zacatek = konec;
      }
      else {
        k.dalsi = konec;
      }
    }
  
    int vyber() {
      int v = zacatek.klic;
      zacatek = zacatek.dalsi;
      return v;
    }
  }
   
//***********************************************************************
    void zadaniGrafu () {     // Metoda  pomoci ktere zadame graf jako seznam sousedu ke kazdemu vrcholu
        System.out.println ("Zadejte pocet vrcholu..." );
        int V = ctiInt()+1;
        /*Vrchol [] */ vrcholy = new Vrchol [V];
        for (int i = 1 ; i < vrcholy.length ; i++ ) {
          int nacteni = 0;
          vrcholy [i] = new Vrchol ();
          do {
          System.out.println ("Zadejte sousedy vrcholu  " + i  +" ,stisknete '0' pro skok na dalsi vrchol  ");
          nacteni = ctiInt ();
          if (nacteni != 0) {
            if (nacteni > V-1 ){
            System.out.println (" Vlozen neexistujici soused!!!");
            }
            else {
            if ( vrcholy [i].sousedi == null ) {
            Soused  x = new Soused (nacteni);
            vrcholy [i].sousedi = x; 
           
          }
            else {
           Soused pom = vrcholy [i].sousedi; 
           Soused x = new Soused (nacteni);
           vrcholy [i].sousedi = x;
           x.dalsi = pom;
            }
          }
          }
          }while ( nacteni != 0);
        } 

    
    } 
//-----------------------------------------------------

   void tiskGrafu (){      // metoda, ktera vytiskne zadany graf tak, ze pod sebe vypise vrcholy a vedle nich jejich sousedy
  for (int i = 1 ; i < vrcholy.length; i++ ) {
  System.out.print ("Vrchol " + i + " ma sousedy : ");
  if ( vrcholy[i].sousedi != null ) {
  System.out.print ( "  " + vrcholy[i].sousedi.hod + " , " );
  Soused x = vrcholy[i].sousedi.dalsi;
  while ( x != null ) {
  System.out.print ("  " + x.hod + " , " ); 
  x = x.dalsi;
  }
  
}
  System.out.println (); }
      
}  
//------------------------------------------
      void dfs (int s) {  // metoda prochazejici graf do hloubky a vypisujici "zacernene" vrcholy
      int cas = 0;
      System.out.println("Pruchod DFS:");
      dfsPom(s,cas);
      for (int i = 1; i < vrcholy.length -1 ; i++) {
        if (vrcholy[i].objeven == 0) {
          dfsPom (i,cas);
        }
      }
    }
    
    void dfsPom (int s,int cas) {
      vrcholy[s].barva = 'S';
      cas = cas + 1;
      vrcholy[s].objeven = cas;
      Soused x = vrcholy[s].sousedi;
      while ( x != null ) {
        if ( vrcholy[x.hod].barva == 'B' ) {
          vrcholy[x.hod].predchudce = s;
          dfsPom(x.hod,cas);
        }
        x = x.dalsi;
      }
      vrcholy[s].barva = 'C';
      System.out.print(s+" ");
      vrcholy[s].dokoncen = cas = cas + 1;
    }
   

//-------------------------------------
    private int ctiInt() {            // metoda slouzici k nacteni dat z klavesnice
      byte[] pole = new byte[200];
      try { 
         System.in.read(pole);
         return Integer.parseInt(new String(pole).trim());
      } 
      catch (Exception e) {
        System.out.println("Chybne nactene cislo !");
      return 0;
      }
    }
}